Anypoint Amazon SNS Connector Demo
==================================

## INTRODUCTION

The current demo application provides a workflow to invoke SNS API operations for Create Topic, Subscribe to a topic, Publish Message, Unsubscribe Topic, Delete Topic.

## Prerequisites

In order to build and run this project, you'll need;

* Java 7 and above
* Anypoint Studio with Mule ESB 3.7.x EE or higher Runtime.
* Anypoint Amazon SNS Connector v2.2.0 or higher.
* Amazon SNS & SQS Credentials.
* Latest web browser to run this demo.

## Import the project

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")
* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).
* Click **Finish**.
* Set SNS and SQS credentials inside the file `src/main/app/mule-app.properties`. This may vary depending on the selected connection configuration. The current demo uses below details:

    ```
    amazon.sns.accesskey=
    amazon.sns.secretkey=
    amazon.sns.topic=
    //below is optional
    amazon.sns.topic.test.arn=
    amazon.sns.region=
    amazon.sns.sqsToSubscribe=
    ```

* Open the **Global Element Configuration**.
* Fill Access Key, Secret Key, Region. see the image below for reference.

![Demo SNS Configuration](images/Demo-sns-configuration.png)

* Click the **Test Connection** button to ensure there is connectivity with the sandbox. A successful message should pop-up.

* Open a browser and access the URL **http://localhost:8081**. You should see the demo application deployed:

## Run the demo

### Create Topic

![Demo Create Topic](images/Demo-Create-Topic.png)

* Ensure **amazon.sns.topic** is filled in mule app properties file.
* Click the button **Create Topic** and wait a few moments to finish processing.
* You should see the topic ARN in below textarea box.

### Subscribe

![Demo Subscribe Topic](images/Demo-Subscribe-Topic.png)

* Click the button **Subscribe** and wait a few moments to finish processing.
* You should see the subscription ARN in below textarea box.

### Publish Message

![Demo Publish Message](images/Demo-Publish-Message.png)

* Ensure **Subject** and **Message** is filled.
* Click the button **Publish** and wait a few moments to finish processing.
* You should see the message published successfully and publish id in below textarea box.

### UnSubscribe

![Demo UnSubscribe Topic](images/Demo-Unsubscribe-Topic.png)

* Click the button **UnSubscribe** and wait a few moments to finish processing.
* You should see the success message in below textarea box.

### Delete Topic

![Demo Delete Topic](images/Demo-Delete-Topic.png)

* Click the button **Delete** and wait a few moments to finish processing.
* You should see the success message in below textarea box.

## See more

* For additional technical information on the SNS Connector, visit our [technical reference documentation](http://mulesoft.github.io/sns-connector/) or refer to the [SNS Documentation Site](https://docs.mulesoft.com/mule-user-guide/v/3.8/amazon-sns-connector).
* For more information on the SNS API, go to the [SNS API documentation page](https://aws.amazon.com/documentation/sns/).
